<?php

namespace Dedi\SyliusSogenactifPlugin\Payum\Sogenactif;

class SealEncoder implements SealEncoderInterface
{
    public function createSeal(array $data, string $secretKey)
    {
        return $this->hashWithAlgo('sha256', $this->concateStrineWith($data), $secretKey);
    }

    public function encodeUtf8(string $toEncoded = '')
    {
        return utf8_encode($toEncoded);
    }

    public function concateStrineWith(array $data)
    {
        $result = '';

        foreach ($data as $value) {
            $result .= $value;
        }

        return $result;
    }

    public function hashWithAlgo(string $algo, string $data, string $key)
    {
        return hash_hmac($algo, $data, $key);
    }
}
